package com.its.api.its.service.link;

import com.its.api.its.model.dto.link.TbLinkSyopTrafDto;
import com.its.api.its.model.dto.link.TbLinkSyopTrafKeyDto;
import com.its.api.its.model.entity.link.TbLinkSyopTraf;
import com.its.api.its.model.entity.link.TbLinkSyopTrafKey;
import com.its.api.its.repository.link.TbLinkSyopTrafRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbLinkSyopTrafService {

    private final TbLinkSyopTrafRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbLinkSyopTraf requireOne(TbLinkSyopTrafKey id) {
        return this.repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    /**
     * 종료되지 않은 운영자 소통정보 전체 조회
     * @return
     */
    public List<TbLinkSyopTrafDto> findAllCurrent() {
        List<TbLinkSyopTrafDto> result = new ArrayList<>();
        List<TbLinkSyopTraf> data = this.repo.findAllCurrent();
        for (TbLinkSyopTraf entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbLinkSyopTrafDto> mergeInfoList(List<TbLinkSyopTrafDto.TbLinkSyopTrafUpdReq> reqList) {
        List<TbLinkSyopTrafDto> result = new ArrayList<>();
        for (TbLinkSyopTrafDto.TbLinkSyopTrafUpdReq req : reqList) {
            TbLinkSyopTraf obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbLinkSyopTrafDto> deleteByIds(List<TbLinkSyopTrafKeyDto> ids) {
        List<TbLinkSyopTrafDto> result = new ArrayList<>();
        for (TbLinkSyopTrafKeyDto id : ids) {
            TbLinkSyopTrafKey key = new TbLinkSyopTrafKey(id.getLinkId(), id.getCrtnDt());
            Optional<TbLinkSyopTraf> obj = this.repo.findById(key);
            if (obj.isPresent()) {
                this.repo.deleteById(key);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
